<template>
  <div class="belong-to-me">
    <AiTopFixed>
      <u-tabs :list="tabs" :is-scroll="false" :current="index" bar-width="88" :height="96" @change="change"></u-tabs>
    </AiTopFixed>
    <div class="body">
      <template v-if="list.length">
        <div class="card" v-for="(item,index) in list" :key="index" @click="handleClick(item)">
          <header>{{ item.title }}</header>
          <u-row justify="between">
            <div class="time">
              <span>{{ item.startTime|formatTime }}</span>
              <span>{{ item.startTime|formatDate(0) }}年{{
                  item.startTime|formatDate(1)
                }}月{{ item.startTime|formatDate(2) }}日 周{{ item.startTime|formatWeek }}</span>
            </div>
            <div class="arrow"></div>
            <div class="time">
              <span>{{ item.endTime|formatTime }}</span>
              <span>{{ item.endTime|formatDate(0) }}年{{ item.endTime|formatDate(1) }}月{{ item.endTime|formatDate(2) }}日 周{{
                  item.endTime|formatWeek
                }}</span>
            </div>
          </u-row>
<!--          <u-row class="info">-->
<!--            <span>发起单位：</span>-->
<!--            <AiOpenData type="departmentName" :openid="item.unitName"/>-->
<!--          </u-row>-->
          <u-gap height="20"></u-gap>
          <u-row class="info">
            <span>会议地点：</span>
            <span>{{ item.address }}</span>
          </u-row>
          <div class="tag" :style="{background:'url(' + tag(item.status) + ')'}"></div>
        </div>
      </template>
      <template v-else>
        <AiEmpty/>
      </template>
    </div>
  </div>
</template>

<script>
import {mapActions} from "vuex";

export default {
  name: "belongToMe",
  data() {
    return {
      index: 0,
      current: 1,
      list: [],
      status: "加载更多",
    }
  },
  computed: {
    tabs() {
      return [
        {name: "全部"},
        {name: "未开始"},
        {name: "进行中"},
        {name: "已取消"},
        {name: "已结束"},
      ]
    }
  },
  onShow() {
    document.title = "我发起的";
  },
  created() {
    this.injectJWeixin(['sendChatMessage']).then(() => {
      this.getList()
    })
  },
  onReachBottom() {
    this.current++;
    this.getList()
  },
  methods: {
    ...mapActions(['injectJWeixin']),
    tag(status) {
      return {
        "1": this.$cdn + 'common/1wks.png',
        "2": this.$cdn + 'common/1jxz.png',
        "3": this.$cdn + 'common/1yqx.png',
        "4": this.$cdn + 'common/1yjs.png'
      }[status]
    },
    getList() {
      this.$http.post("/app/appmeetinginfo/list", null, {
        params: {
          listType: 0,
          meetingStatus: this.index == 0 ? "-1" : this.index,
          size: 10,
          current: this.current
        }
      }).then(res => {
        if (res && res.data) {
          if (this.current > 1 && this.current > res.data.pages) {
            this.status = "已经到底啦"
          }
          this.list = this.current > 1 ? [...this.list, ...res.data.records] : res.data.records
        }
      })
    },
    handleClick({id}) {
      uni.navigateTo({
        url: "/apps/AppMeetingNotice/detail?id=" + id
      })
    },
    change(e) {
      this.index = e
      this.current = 1
      this.getList()
    },
  },

  filters: {
    formatTime(date) {
      return date.split(" ")[1]?.substr(0, 5)
    },
    formatDate(date, i) {
      return date.split(" ")[0]?.split("-")[i]
    },
    formatWeek(date) {
      return "日一二三四五六".charAt(new Date(date.split(" ")[0]).getDay())
    },
  }
}
</script>

<style lang="scss" scoped>
.belong-to-me {
  min-height: 100%;
  background-color: #F5F5F5;

  ::v-deep .content {
    padding: 0 !important;
  }

  .body {
    box-sizing: border-box;
    padding: 40px 32px;

    .card {
      background-color: #FFFFFF;
      box-sizing: border-box;
      padding: 32px;
      border-radius: 8px;
      margin-bottom: 32px;
      position: relative;

      &:last-child {
        margin-bottom: 0;
      }

      & > header {
        width: 95%;
        font-size: 32px;
        font-weight: 600;
        color: #333333;
      }

      .time {
        display: flex;
        flex-direction: column;
        margin: 46px 0;

        & > span:first-child {
          font-size: 60px;
          font-weight: 600;
          color: #333333;
          line-height: 84px;
        }

        & > span:last-child {
          font-size: 22px;
          color: #333333;
        }
      }

      .arrow {
        width: 28px;
        height: 68px;
        overflow: hidden;
        position: relative;
        transform: rotate(180deg);

        &:before, &:after {
          content: "";
          width: 50px;
          height: 50px;
          position: absolute;
          transform: scaleY(1.3) translate(30%, -40px) rotate(45deg);
        }

        &:before {
          top: 59px;
          background-color: #CCCCCC;
        }

        &:after {
          left: 7px;
          top: 59px;
          background-color: #FFFFFF;
        }
      }

      .info {
        flex-wrap: nowrap;

        & > span:first-child {
          font-size: 30px;
          color: #999999;
          flex-shrink: 0;
        }

        & > span:last-child {
          font-size: 30px;
          color: #343D65;
        }
      }

      .tag {
        width: 112px;
        height: 112px;
        background-repeat: no-repeat;
        background-size: 100% 100% !important;
        position: absolute;
        top: 0;
        right: 0;
      }
    }
  }
}
</style>
